{$G+}
uses crt;

type	mc6800 = record
	a:	byte;
	b:	byte;
	x:	word;
	sp:	word;
	p:	byte;
	pc:	word; 
	end;
type	bios = record
	ch:	byte;
	cnt:	integer;
	x:	byte;
	y:	byte;
	gx:	byte;
	gy:	byte;
	end;
var	ram:	array[0..32767] of byte;
{	dram:	array[0..32767] of word; }
	r:	mc6800;
	f:	file of byte;
	name:	string;
	prm:	BYTE;
	drm:	char;
	dat:	bios;
{	pc:	word; }

{ procedure ramw(a: word; z: byte);
var 	i,o:	word;
	b:	byte;
begin
 asm
 clr	b
 mov	ax,a
 shr	ax,1
 jc	@Hih
 mov	b,255
@Hih:
 mov	i,ax
 end;
if b=0 then begin
		o:=dram[i];
		asm
		mov	ax,o
		mov	ah,z
		mov	o,ax
		end;
		dram[i]:=o;
	     end
	else begin
		o:=dram[i];
		asm
		mov	ax,o
		mov	al,z
		mov	o,ax
		end;
		dram[i]:=o;
	     end;
end;

function ramr(a: word): byte;
var 	i,o:	word;
	b:	byte;
begin
 asm
 clr	b
 mov	ax,a
 shr	ax,1
 jc	@Hih
 mov	b,255
@Hih:
 mov	i,ax
 end;
if b=0 then begin
		o:=dram[i];
		asm
		mov	ax,o
		mov	b,ah
		end;
	     end
	else begin
		o:=dram[i];
		asm
		mov	ax,o
		mov	b,al
		end;
	     end;
ramr:=b;
end;
}

procedure fread;
var i: integer;
begin
assign(f,name);
 reset(f);
i:=$100;
while not eof(f) do
 begin
  read(f,ram[i]);
  inc(i);
 end;
r.a:=0;
r.b:=0;
r.x:=0;
r.sp:=32767;
r.p:=0;
r.pc:=$100;
end;

procedure p_aba;
begin
 asm
 mov	dl,r.p
 and	dl,$F2
 mov	al,r.a
 mov	bl,r.b
 add	al,bl
 jnc	@M
 or	dl,1
@M:
 jnz	@M1
 or	dl,4
@M1:
 jns	@M2
 or	dl,8
@M2:
 mov	r.p,dl
 end;
 inc(r.pc);
end;
procedure p_clc;
begin
 asm
 mov	al,r.p
 and	al,$FE
 mov	r.p,al
 end;
inc(r.pc);
end;
procedure p_cli;
begin
 asm
 mov	al,r.p
 and	al,$F7
 mov	r.p,al
 end;
inc(r.pc);
end;
procedure p_clv;
begin
 asm
 mov	al,r.p
 and	al,$FD
 mov	r.p,al
 end;
inc(r.pc);
end;
procedure p_clra;
begin
 r.a:=0;
  asm
  mov	al,r.p
  and	al,$F0
  or	al,4
  mov	r.p,al
  end;
 inc(r.pc);
end;
procedure p_clrb;
begin
 r.b:=0;
  asm
  mov	al,r.p
  and	al,$F0
  or	al,4
  mov	r.p,al
  end;
 inc(r.pc);
end;

procedure p_ldx3;
var	q,w:	byte;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	r.x,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ax,$8000
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;

procedure p_lds3;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ax,$8000
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.sp:=o;
r.pc:=r.pc+3;
end;

procedure p_ldaa3;
var	q:	byte;
begin
q:=ram[r.pc+1];
 asm
 mov	al,q
 mov	r.a,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_ldab3;
var	q:	byte;
begin
q:=ram[r.pc+1];
 asm
 mov	al,q
 mov	r.b,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_ldaa4;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
r.a:=ram[q];
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_ldab4;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
r.b:=ram[q];
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_ldx4;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
w:=ram[q];
e:=ram[q+1];
 asm
 mov	al,e
 mov	ah,w
 mov	r.x,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_lds4;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
w:=ram[q];
e:=ram[q+1];
 asm
 mov	al,e
 mov	ah,w
 mov	q,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.sp:=q;
r.pc:=r.pc+2;
end;

procedure p_ldab5;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
r.b:=ram[q];
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_ldaa5;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
r.a:=ram[q];
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_lds5;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
w:=ram[q];
e:=ram[q+1];
 asm
 mov	al,e
 mov	ah,w
 mov	q,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.sp:=q;
r.pc:=r.pc+2;
end;

procedure p_ldx5;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
w:=ram[q];
e:=ram[q+1];
 asm
 mov	al,e
 mov	ah,w
 mov	r.x,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_ldx6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
q:=ram[o];
w:=ram[o+1];
 asm
 mov	ah,q
 mov	al,w
 mov	r.x,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ax,$8000
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;

procedure p_lds6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
q:=ram[o];
w:=ram[o+1];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ax,$8000
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.sp:=o;
r.pc:=r.pc+3;
end;

procedure p_ldaa6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
r.a:=ram[o];
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;

procedure p_ldab6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
r.b:=ram[o];
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;
{ save to }
procedure p_staa4;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
ram[q]:=r.a;
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_stab4;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
ram[q]:=r.b;
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_stx4;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
 asm
 mov	ax,r.x
 mov	w,ah
 mov	e,al
 end;
ram[q]:=w;
ram[q+1]:=e;
 asm
 mov	al,e
 mov	ah,w
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_sts4;
var	q,o:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w;
 o:=r.sp;
 asm
 mov	ax,o
 mov	w,ah
 mov	e,al
 end;
ram[q]:=w;
ram[q+1]:=e;
 asm
 mov	al,e
 mov	ah,w
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ah,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_stab5;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
ram[q]:=r.b;
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_staa5;
var	q:	integer;
	w:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
ram[q]:=r.a;
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_sts5;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
ram[q]:=hi(r.sp);
ram[q+1]:=lo(r.sp);
q:=r.sp;
 asm
 mov	ax,q
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ah,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_stx5;
var	q:	integer;
	w,e:	byte;
begin
w:=ram[r.pc+1];
 q:=w+r.x;
ram[q]:=hi(r.x);
ram[q+1]:=lo(r.x);
 asm
 mov	ax,r.x
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+2;
end;

procedure p_stx6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
ram[o]:=hi(r.x);
ram[o+1]:=lo(r.x);
 asm
 mov	ax,r.x
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ax,$8000
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;

procedure p_sts6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
ram[o]:=hi(r.sp);
ram[o+1]:=lo(r.sp);
o:=r.sp;
 asm
 mov	ax,o
 mov	bl,r.p
 and	bl,$F9
 cmp	ax,0
 jnz	@M
 or	bl,4
@M:
 test	ax,$8000
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.sp:=o;
r.pc:=r.pc+3;
end;

procedure p_staa6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
ram[o]:=r.a;
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;

procedure p_stab6;
var	q,w:	byte;
	o:	integer;
begin
q:=ram[r.pc+1];
w:=ram[r.pc+2];
 asm
 mov	ah,q
 mov	al,w
 mov	o,ax
 end;
ram[o]:=r.b;
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
r.pc:=r.pc+3;
end;

procedure p_adca(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 add	al,ah
 mov	ah,r.p
 and	ah,$1
 add	al,ah
 pushf
 mov	r.a,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 test	ax,$10
 jnz	@M3
 or	bl,$20
@M3:
 mov	r.p,bl
 end;
end;

procedure p_adcb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 add	al,ah
 mov	ah,r.p
 and	ah,$1
 add	al,ah
 pushf
 mov	r.b,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0 
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 test	ax,$10
 jnz	@M3
 or	bl,$20
@M3:
 mov	r.p,bl
 end;
end;

procedure p_adda(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 add	al,ah
 pushf
 mov	r.a,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 test	ax,$10
 jnz	@M3
 or	bl,$20
@M3:
 mov	r.p,bl
 end;
end;

procedure p_addb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 add	al,ah
 pushf
 mov	r.b,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 test	ax,$10
 jnz	@M3
 or	bl,$20
@M3:
 mov	r.p,bl
 end;
end;

procedure p_anda(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 and	al,ah
 mov	r.a,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_andb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 and	al,ah
 mov	r.b,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_sbca(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	ah,q
 mov	al,r.a
 sub	al,ah
 mov	ah,r.p
 and	ah,$1
 sub	al,ah
 pushf
 mov	r.a,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 mov	r.p,bl
 end;
end;

procedure p_sbcb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	ah,q
 mov	al,r.b
 sub	al,ah
 mov	ah,r.p
 and	ah,$1
 sub	al,ah
 pushf
 mov	r.b,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 mov	r.p,bl
 end;
end;

procedure p_suba(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 sub	ah,al
 pushf
 mov	r.a,ah
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 mov	r.p,bl
 end;
end;

procedure p_subb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 sub	ah,al
 pushf
 mov	r.b,ah
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 mov	r.p,bl
 end;
end;

procedure p_sba;
begin
 asm
 mov	al,r.a
 mov	ah,r.b
 sub	al,ah
 pushf
 mov	r.a,al
 mov	bl,r.p
 and	bl,$E0
 pop	ax
 push	ax
 popf
{ test	ax,$1 }
 jnc	@M0
 or	bl,1
@M0:
 test	ax,$40
 jnz	@M
 or	bl,4
@M:
 test	ax,$80
 jnz	@M1
 or	bl,8
@M1:
 test	ax,$800
 jnz	@M2
 or	bl,2
@M2:
 mov	r.p,bl
 end;
end;

procedure p_oraa(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 or	al,ah
 mov	r.a,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_orab(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 or	al,ah
 mov	r.b,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_eora(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 xor	al,ah
 mov	r.a,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_eorb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 xor	al,ah
 mov	r.b,al
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure mod_pc;
var a:	byte;
begin
a:=ram[r.pc+1];
r.pc:=r.pc+2;
 asm
 mov	bx,r.pc
 xor	ah,ah
 mov	al,a
 or	al,al
 jns	@MQ
 mov	ah,$FF
@MQ:
 add	ax,bx
{ test	al,$80
 jnz	@M
 neg	al
 sub	bx,ax
 jmp	@M1
@M:
 add	ax,bx
@M1: }
 mov	r.pc,ax
 end;
end;

procedure p_bra;
begin
mod_pc;
end;

procedure p_bsr;
var	q:	integer;
begin
 q:=r.pc+2;
 ram[r.sp]:=lo(q);
 ram[r.sp-1]:=hi(q);
 r.sp:=r.sp-2;
 mod_pc;
end;

procedure p_bcc;
begin
 if (r.p and 1)=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bcs;
begin
 if (r.p and 1)=1 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bne;
begin
 if (r.p and 4)=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_beq;
begin
 if (r.p and 4)<>0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bge;
begin
 if ((r.p and 8) xor (r.p and 2))=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bgt;
begin
 if (((r.p and 8) xor (r.p and 2)) or (r.p and 4))=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_ble;
begin
 if (((r.p and 8) xor (r.p and 2)) or (r.p and 4))<>0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_blt;
begin
 if ((r.p and 8) xor (r.p and 2))<>0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bls;
begin
 if ((r.p and 1) or (r.p and 4))<>0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bhi;
begin
 if ((r.p and 1) or (r.p and 4))=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bmi;
begin
 if (r.p and 8)=8 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bpl;
begin
 if (r.p and 8)=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bvc;
begin
 if (r.p and 2)=0 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_bvs;
begin
 if (r.p and 2)=2 then mod_pc
 else r.pc:=r.pc+2;
end;

procedure p_dec(n: byte);
var	q,w:	byte;
	o: 	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 dec	al
 mov	w,al
 mov	bl,r.p
 jnc	@M0
 or	bl,2
@M0:
 and	bl,$FB
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;
 
procedure p_clr(n: byte);
var	q,w:	byte;
	o: 	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		ram[q+r.x]:=0;
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		ram[o]:=0;
		r.pc:=r.pc+3;
		end;
asm
mov	al,r.p
and	al,$F0
or	al,4
mov	r.p,al
end;
end;

procedure p_inc(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 inc	al
 mov	w,al
 mov	bl,r.p
 jnc	@M0
 or	bl,2
@M0:
 and	bl,$FB
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_deca;
begin
 asm
 mov	al,r.a
 dec	al
 mov	r.a,al
 mov	bl,r.p
 jnc	@M0
 or	bl,2
@M0:
 and	bl,$FB
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_decb;
begin
 asm
 mov	al,r.b
 dec	al
 mov	r.b,al
 mov	bl,r.p
 jnc	@M0
 or	bl,2
@M0:
 and	bl,$FB
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_inca;
begin
 asm
 mov	al,r.a
 inc	al
 mov	r.a,al
 mov	bl,r.p
 jnc	@M0
 or	bl,2
@M0:
 and	bl,$FB
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_incb;
begin
 asm
 mov	al,r.b
 inc	al
 mov	r.b,al
 mov	bl,r.p
 jnc	@M0
 or	bl,2
@M0:
 and	bl,$FB
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_des;
begin
 dec(r.sp);
 inc(r.pc);
end;

procedure p_ins;
begin
 inc(r.sp);
 inc(r.pc);
end;

procedure p_dex;
begin
 dec(r.x);
 inc(r.pc);
 if r.x=0 then r.p:=r.p or 4
 else r.p:=r.p and $FB;
end;

procedure p_inx;
begin
 inc(r.x);
 inc(r.pc);
 if r.x=0 then r.p:=r.p or 4
 else r.p:=r.p and $FB;
end;

procedure p_com(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 xor	al,$FF
 mov	w,al
 mov	bl,r.p
 and	bl,$FC
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_coma;
begin
 asm
 mov	al,r.a
 xor	al,$FF
 mov	r.a,al
 mov	bl,r.p
 and	bl,$FC
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_comb;
begin
 asm
 mov	al,r.b
 xor	al,$FF
 mov	r.b,al
 mov	bl,r.p
 and	bl,$FC
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_neg(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 neg	al
 mov	w,al
 mov	bl,r.p
 and	bl,$FC
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_nega;
begin
 asm
 mov	al,r.a
 neg	al
 mov	r.a,al
 mov	bl,r.p
 and	bl,$FC
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_negb;
begin
 asm
 mov	al,r.b
 neg	al
 mov	r.b,al
 mov	bl,r.p
 and	bl,$FC
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_jmp(n: byte);
var	q,w:	byte;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		w:=ram[q+r.x+1];
		asm
		mov	ah,q
		mov	al,w
		mov	r.pc,ax
		end;
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	r.pc,ax
		end;
 	     end;
end;

procedure p_jsr(n: byte);
var	q,w:	byte;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		w:=ram[q+r.x+1];
		r.pc:=r.pc+2;
		ram[r.sp]:=lo(r.pc);
		ram[r.sp-1]:=hi(r.pc);
		r.sp:=r.sp-2;
		asm
		mov	ah,q
		mov	al,w
		mov	r.pc,ax
		end;
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		r.pc:=r.pc+3;
		ram[r.sp]:=lo(r.pc);
		ram[r.sp-1]:=hi(r.pc);
		r.sp:=r.sp-2;
		asm
		mov	ah,q
		mov	al,w
		mov	r.pc,ax
		end;
 	     end;
end;

procedure p_rts;
var	q,w:	byte;
begin
 q:=ram[r.sp+1];
 w:=ram[r.sp+2];
 r.sp:=r.sp+2;
 asm
 mov	ah,q
 mov	al,w
 mov	r.pc,ax
 end;
end;

procedure p_psha;
begin
 ram[r.sp]:=r.a;
 dec(r.sp);
 inc(r.pc);
end;

procedure p_pshb;
begin
 ram[r.sp]:=r.b;
 dec(r.sp);
 inc(r.pc);
end;

procedure p_pula;
begin
 inc(r.pc);
 inc(r.sp);
 r.a:=ram[r.sp];
end;

procedure p_pulb;
begin
 inc(r.pc);
 inc(r.sp);
 r.b:=ram[r.sp];
end;

procedure p_tap;
begin
 r.p:=r.a;
 inc(r.pc);
end;

procedure p_tpa;
begin
 r.a:=r.p;
 inc(r.pc);
end;

procedure p_tsx;
begin
 r.x:=r.sp+1;
 inc(r.pc);
end;

procedure p_txs;
begin
 r.sp:=r.x-1;
 inc(r.pc);
end;

procedure p_tab;
begin
 r.b:=r.a;
 asm
 mov	bl,r.a
 mov	al,r.p
 and	al,$F1
 cmp	bl,0
 jnz	@M
 or	al,4
@M:
 test	bl,$80
 jnz	@M1
 or	al,8
@M1:
 mov	r.p,al
 end;
inc(r.pc);
end;

procedure p_tba;
begin
 r.a:=r.b;
 asm
 mov	bl,r.a
 mov	al,r.p
 and	al,$F1
 cmp	bl,0
 jnz	@M
 or	al,4
@M:
 test	bl,$80
 jnz	@M1
 or	al,8
@M1:
 mov	r.p,al
 end;
inc(r.pc);
end;

procedure p_sei;
begin
 r.p:=r.p or $10;
 inc(r.pc);
end;

procedure p_sev;
begin
 r.p:=r.p or 2;
 inc(r.pc);
end;

procedure p_sec;
begin
 r.p:=r.p or 1;
 inc(r.pc);
end;

procedure p_rol(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,q
 rcl	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	w,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_ror(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,q
 rcr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	w,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_rora;
begin
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,r.a
 rcr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.a,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_rola;
begin
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,r.a
 rcl	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.a,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_rorb;
begin
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,r.b
 rcr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.b,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_rolb;
begin
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,r.b
 rcl	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.b,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_lsr(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,q
 shr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$F6
@L2:
 mov	w,al
 and	bl,$F3
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_lsra;
begin
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,r.a
 shr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.a,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_lsrb;
begin
 asm
 mov	bl,r.p
 clc
 test	bl,1
 jnz	@L
 stc
@L:
 mov	al,r.b
 shr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.b,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_asl(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	bl,r.p
 clc
 mov	al,q
 rcl	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	w,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_asr(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	bl,r.p
 clc
 mov	al,q
 rcr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	w,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
if n=5 then ram[r.pc-1+r.x]:=w;
if n=6 then ram[o]:=w;
end;

procedure p_asra;
begin
 asm
 mov	bl,r.p
 clc
 mov	al,r.a
 rcr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.a,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_asla;
begin
 asm
 mov	bl,r.p
 clc
 mov	al,r.a
 rcl	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.a,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_asrb;
begin
 asm
 mov	bl,r.p
 clc
 mov	al,r.b
 rcr	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.b,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_aslb;
begin
 asm
 mov	bl,r.p
 clc
 mov	al,r.b
 rcl	al,1
 jnc	@L1
 or	bl,3
 jmp	@L2
@L1:
 and	bl,$FE
@L2:
 mov	r.b,al
 and	bl,$F1
 or	bl,1
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_tst(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	bl,r.p
 and	bl,$FC
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_tsta;
begin
 asm
 mov	al,r.a
 mov	bl,r.p
 and	bl,$FC
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_tstb;
begin
 asm
 mov	al,r.b
 mov	bl,r.p
 and	bl,$FC
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_cba;
begin
 asm
 mov	al,r.a
 mov	ah,r.b
 mov	bl,r.p
 and	bl,$F0
 cmp	al,ah
 jnc	@M
 or	bl,1
@M:
 cmp	al,ah
 jnz	@M1
 or	bl,4
@M1:
 cmp	al,ah
 jns	@M2
 or	bl,8
@M2:
 cmp	al,ah
 jno	@M3
 or	bl,2
@M3:
 mov	r.p,bl
 end;
inc(r.pc);
end;

procedure p_cmpa(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	ah,q
 mov	al,r.a
 mov	bl,r.p
 and	bl,$F0
 cmp	al,ah
 jnc	@M
 or	bl,1
@M:
 cmp	al,ah
 jnz	@M1
 or	bl,4
@M1:
 cmp	al,ah
 jns	@M2
 or	bl,8
@M2:
 cmp	al,ah
 jno	@M3
 or	bl,2
@M3:
 mov	r.p,bl
 end;
end;
 
procedure p_cmpb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	ah,q
 mov	al,r.b
 mov	bl,r.p
 and	bl,$F0
 cmp	al,ah
 jnc	@M
 or	bl,1
@M:
 cmp	al,ah
 jnz	@M1
 or	bl,4
@M1:
 cmp	al,ah
 jns	@M2
 or	bl,8
@M2:
 cmp	al,ah
 jno	@M3
 or	bl,2
@M3:
 mov	r.p,bl
 end;
end;

procedure p_bita(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.a
 and	al,ah
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_bitb(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; r.pc:=r.pc+2; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		r.pc:=r.pc+3;
		end;
 asm
 mov	al,q
 mov	ah,r.b
 and	al,ah
 mov	bl,r.p
 and	bl,$F9
 cmp	al,0
 jnz	@M
 or	bl,4
@M:
 test	al,$80
 jnz	@M1
 or	bl,8
@M1:
 mov	r.p,bl
 end;
end;

procedure p_cpx(n: byte);
var	q,w:	byte;
	o:	integer;
begin
if n=3 then begin q:=ram[r.pc+1]; w:=ram[r.pc+2]; r.pc:=r.pc+3; end;
if n=4 then begin
	    q:=ram[r.pc+1];
	    w:=ram[q+1];
	    q:=ram[q];
	    r.pc:=r.pc+2;
	    end;
if n=5 then begin
		q:=ram[r.pc+1];
		w:=ram[q+1+r.x];
		q:=ram[q+r.x];
		r.pc:=r.pc+2
	    end;
if n=6 then begin
		q:=ram[r.pc+1];
		w:=ram[r.pc+2];
		asm
		mov	ah,q
		mov	al,w
		mov	o,ax
		end;
		q:=ram[o];
		w:=ram[o+1];
		r.pc:=r.pc+3;
		end;
 asm
 mov	ah,q
 mov	al,w
 mov	bl,r.p
 and	bl,$F1
 cmp	ax,r.x
 pushf
 jnz	@M
 or	bl,4
@M:
 popf
 pushf
 jns	@M1
 or	bl,8
@M1:
 popf
 jno	@M2
 or	bl,2
@M2:
 mov	r.p,bl
 end;
end;

procedure hexnibbl(n: byte);
begin
 if n>9 then write(chr(65+n-10))
	else write(n);
end;

procedure hexbyte(b: byte);
var c: byte;
begin
asm
 mov	al,b
 ror	al,4
 and	al,$0F
 mov	c,al
end;
 hexnibbl(c);
 hexnibbl(b and 15);
end;

procedure hexword(w: word);
begin
 hexbyte(hi(w));
 hexbyte(lo(w));
end;


procedure p_char(c: byte);
begin
 if dat.ch=0 then begin if (c>$1F) and (c<>$7F) then begin inc(dat.gx);
							   write(chr(c));
							   if dat.gx=41 then begin
										writeln;
										dat.gx:=1;
									     end;
						     end;
		  	if c=$1E then dat.ch:=$1E;
			if c=$1B then dat.ch:=c;
			if c=$09 then write('	');
			if c=$0A then write(chr($0A));
			if c=$08 then	begin
					asm
					mov	ah,3
					mov	bh,0
					int	$10
					mov	ah,2
					mov	bh,0
					dec	dl
					int	$10
					end;
					end;
			if c=$0D then begin dat.gx:=1; write(chr($0D));
			if c=$7F then	begin
					asm
					mov	ah,3
					mov	bh,0
					int	$10
					mov	ah,2
					mov	bh,0
					dec	dl
					int	$10
					mov	ah,$0A
					mov	bh,0
					mov	al,32
					mov	cx,1
					int	$10
					end;
					end;
					end;
		end
 		else begin
 if dat.ch=$1B then begin
			inc(dat.gx);
		     write(chr(c));
		     dat.ch:=0;
			if dat.gx=41 then begin
					  dat.gx:=1;
					  writeln;
					  end;
		    end;
 if dat.ch=$1E then begin
			if dat.cnt=1 then begin
						dat.cnt:=2;
						dat.y:=c;
						dat.ch:=0;
						asm
						mov	ah,02
						mov	bh,0
						mov	dl,dat.x
						sub	dl,$20
						mov	dh,dat.y
						sub	dh,$20
						int	$10
						end;
					   end;
			if dat.cnt=0 then begin
						dat.cnt:=1;
						dat.x:=c;
					  end;
		    end;
end;
if dat.cnt=2 then dat.cnt:=0;
end;

procedure m_int10;
begin
 asm
 mov	ah,01
 int	$16
 jz	@Exit
 xor	ah,ah
 int	$16
@Exit:
 mov	r.a,al
 end;
end;

procedure m_int14;
begin
 asm
 mov	ah,3
 mov	bh,0
 int	$10
 mov	r.b,dh
 mov	r.a,dl
 mov	ax,$F000
 mov	r.x,ax
 end;
end;

procedure m_int15;
begin
 asm
 mov	ah,2
 mov	bh,0
 mov	dh,r.b
 mov	dl,r.a
 int	$10
 end;
end;

procedure m_int20;
var	a:	char;
begin
a:=readkey;
 asm
 mov	al,a
 mov	r.a,al
 end;
end;

procedure m_int22;
begin
 p_char(r.a);
end;

procedure m_int23;
var	i: integer;
begin
i:=r.x;
 while ram[i]<>0 do
 begin
  p_char(ram[i]);
  inc(i);
 end;
end;

procedure m_int24;
begin
 write(r.x);
end;

procedure m_int25;
begin
 hexbyte(r.a);
end;

procedure m_int38;
begin
 writeln;
 writeln('Macros INT $38 - exit to DOS.');
 halt(0);
end;

procedure erma;
begin
 writeln;
 write('Invalid macros INT $'); hexbyte(ram[r.pc+1]);
 write(' at PC='); hexword(r.pc); writeln;
end;

procedure p_swi;
begin
 case ram[r.pc+1] of
 $10:	m_int10;
 $14:	m_int14;
 $15:	m_int15;
 $20:	m_int20;
 $22:	m_int22;
 $23:	m_int23;
 $24:	m_int24;
 $25:	m_int25;
 $38:	m_int38;
 else erma;
 end;
r.pc:=r.pc+2;
end;


procedure erro;
begin
writeln;
write('WARNING!!! Invalid opcode at PC='); hexword(r.pc);
writeln;
inc(r.pc);
end;

procedure analis;
var	m:	byte;
begin
 case ram[r.pc] of
 $1B:	p_aba; { aba }
 $0C:	p_clc; { clc }
 $0E:	p_cli; { cli }
 $4F:	p_clra; { clra }
 $5F:	p_clrb; { clrb }
 $0A:   p_clv; { clv }
 $CE:	p_ldx3; { ldx # }
 $8E:	p_lds3; { lds # }
 $86:	p_ldaa3; { ldaa # }
 $C6:	p_ldab3; { ldab # }
 $96:	p_ldaa4; { ldaa $ }
 $D6:	p_ldab4; { ldab $ }
 $9E:	p_lds4; { lds $ }
 $DE:	p_ldx4; { lds $ }
 $A6:	p_ldaa5; { ldaa $ ,x }
 $E6:	p_ldab5; { ldab $ ,x }
 $AE:	p_lds5;
 $EE:	p_ldx5;
 $B6:	p_ldaa6; 
 $F6:	p_ldab6;
 $BE:	p_lds6;
 $FE:	p_ldx6;
 $97:	p_staa4;
 $A7:	p_staa5;
 $B7:	p_staa6;
 $D7:	p_stab4;
 $E7:	p_stab5;
 $F7:	p_stab6;
 $9F:	p_sts4;
 $AF:	p_sts5;
 $BF:	p_sts6;
 $DF:	p_stx4;
 $EF:	p_stx5;
 $FF:	p_stx6;
 $89:	p_adca(3);
 $99:	p_adca(4);
 $A9:	p_adca(5);
 $B9:	p_adca(6);
 $C9:	p_adcb(3);
 $D9:	p_adcb(4);
 $E9:	p_adcb(5);
 $F9:	p_adcb(6);
 $8B:	p_adda(3);
 $9B:	p_adda(4);
 $AB:	p_adda(5);
 $BB:	p_adda(6);
 $CB:	p_addb(3);
 $DB:	p_addb(4);
 $EB:	p_addb(5);
 $FB:	p_addb(6);
 $84:	p_anda(3);
 $94:	p_anda(4);
 $A4:	p_anda(5);
 $B4:	p_anda(6);
 $C4:	p_andb(3);
 $D4:	p_andb(4);
 $E4:	p_andb(5);
 $F4:	p_andb(6);
 $80:	p_suba(3);
 $90:	p_suba(4);
 $A0:	p_suba(5);
 $B0:	p_suba(6);
 $C0:	p_subb(3);
 $D0:	p_subb(4);
 $E0:	p_subb(5);
 $F0:	p_subb(6);
 $82:	p_sbca(3);
 $92:	p_sbca(4);
 $A2:	p_sbca(5);
 $B2:	p_sbca(6);
 $C2:	p_sbcb(3);
 $D2:	p_sbcb(4);
 $E2:	p_sbcb(5);
 $F2:	p_sbcb(6);
 $10:	p_sba;
 $8A:	p_oraa(3);
 $9A:	p_oraa(4);
 $AA:	p_oraa(5);
 $BA:	p_oraa(6);
 $CA:	p_orab(3);
 $DA:	p_orab(4);
 $EA:	p_orab(5);
 $FA:	p_orab(6);
 $88:	p_eora(3);
 $98:	p_eora(4);
 $A8:	p_eora(5);
 $B8:	p_eora(6);
 $C8:	p_eorb(3);
 $D8:	p_eorb(4);
 $E8:	p_eorb(5);
 $F8:	p_eorb(6); 
 $20:	p_bra;
 $8D:	p_bsr;
 $24:	p_bcc;
 $25:	p_bcs;
 $26:	p_bne;
 $27:	p_beq;
 $28:	p_bvc;
 $29:	p_bvs;
 $2A:	p_bpl;
 $2B:	p_bmi;
 $2C:	p_bge;
 $2D:	p_blt;
 $2E:	p_bgt;
 $2F:	p_ble;
 $22:	p_bhi;
 $23:	p_bls;
 $6A:	p_dec(5);
 $7A:	p_dec(6);
 $6C:	p_inc(5);
 $7C:	p_inc(6);
 $4A:	p_deca;
 $5A:	p_decb;
 $4C:	p_inca;
 $5C:	p_incb;
 $31:	p_ins;
 $34:	p_des;
 $09:	p_dex;
 $08:	p_inx;
 $63:	p_com(5);
 $73:	p_com(6);
 $4A:	p_coma;
 $5A:	p_comb;
 $60:	p_neg(5);
 $70:	p_neg(6);
 $40:	p_nega;
 $50:	p_negb;
 $6E:	p_jmp(5);
 $7E:	p_jmp(6);
 $AD:	p_jsr(5);
 $BD:	p_jsr(6);
 $01:	inc(r.pc);
 $39:	p_rts;
 $36:	p_psha;
 $37:	p_pshb;
 $32:	p_pula;
 $33:	p_pulb;
 $16:	p_tab;
 $06:	p_tap;
 $17:	p_tba;
 $07:	p_tpa;
 $0D:	p_sec;
 $0F:	p_sei;
 $0B:	p_sev;
 $3E:	p_sei;
 $69:	p_rol(5);
 $79:	p_rol(6);
 $66:	p_ror(5);
 $76:	p_ror(6);
 $49:	p_rola;
 $59:	p_rolb;
 $46:	p_rora;
 $56:	p_rorb;
 $64:	p_lsr(5);
 $74:	p_lsr(6);
 $44:	p_lsra;
 $54:	p_lsrb;
 $68:	p_asl(5);
 $78:	p_asl(6);
 $67:	p_asr(5);
 $77:	p_asr(6);
 $48:	p_asla;
 $58:	p_aslb;
 $47:	p_asra;
 $57:	p_asrb;
 $6D:	p_tst(5);
 $7D:	p_tst(6);
 $4D:	p_tsta;
 $5D:	p_tstb;
 $11:	p_cba;
 $81:	p_cmpa(3);
 $91:	p_cmpa(4);
 $A1:	p_cmpa(5);
 $B1:	p_cmpa(6);
 $C1:	p_cmpa(3);
 $D1:	p_cmpa(4);
 $E1:	p_cmpa(5);
 $F1:	p_cmpa(6);
 $85:	p_bita(3);
 $95:	p_bita(4);
 $A5:	p_bita(5);
 $B5:	p_bita(6);
 $C5:	p_bitb(3);
 $D5:	p_bitb(4);
 $E5:	p_bitb(5);
 $F5:	p_bitb(6);
 $8C:	p_cpx(3);
 $9C:	p_cpx(4);
 $AC:	p_cpx(5);
 $BC:	p_cpx(6);
 $3B:	p_rts; { rti }
 $19:	inc(r.pc); { daa }
 $3F:	p_swi; { swi }
 $6F:	p_clr(5);
 $7F:	p_clr(6);
 else erro;
 end;
end;

procedure Print_reg;
begin
 write(' A='); hexbyte(r.a);
 write(' B='); hexbyte(r.b);
 write(' X='); hexword(r.x);
 write(' SP='); hexword(r.sp);
 write(' PC='); hexword(r.pc);
 write(' P='); hexbyte(r.p);
 write(' [PC]='); hexbyte(ram[r.pc]); writeln;
end;

function scankey: byte;
var	z,w: byte;
begin
asm
 mov	ah,01
 int	$16
 jz	@Exit
 xor	ah,ah
 int	$16
@Exit:
 mov	z,al
 mov	w,ah
end;
if w=$58 then prm:=1;
if w=$57 then prm:=0;
scankey:=z;
end;

procedure trass;
var s: char;
begin
{ print_reg; }
while scankey<>$1B do
 begin
{ if prm=0 then begin print_reg; drm:=ReadKey; end; }
 analis;
 end;
end; 

begin

 asm
  mov	ax,1
  int	$10
  mov	ax,$0500
  int	$10
 end;

dat.ch:=0;
dat.cnt:=0;
dat.gx:=1;

writeln('               601');
writeln;
writeln('Virtual UniBIOS ROM installed.');
writeln('Virtual UniDOS  ROM installed.');
writeln('Virtual DRAM 32 KB. installed.');
writeln('Floppy A: installed on Hard C:');
delay(2300);
ClrScr;
writeln('DIANA SYSTEM: ꫤ 601 Emulator v1.0b');
writeln('Copyright (C) ChAle, inc.      1997');
writeln('          (C) Chukov Alexander 1997');
delay(100);

if paramcount<1 then begin
			writeln('Usage: debug.exe file');
			halt(0);
		     end;
name:=paramstr(1);
writeln; writeln('A:\',name);
prm:=0;
{ if paramstr(2)='G' then prm:=0
		     else prm:=1; }
 fread;
 trass;
 Print_reg;
{ drm:=ReadKey;
asm
mov	ax,0
int	$10
end; }
end.
